use std::fs::{File,OpenOptions};
use std::io::prelude::*;
use std::io::{BufReader,self};

fn main() -> io::Result<()> {
    let mut file = match OpenOptions::new().write(true).read(true).open("/sys/devices/system/cpu/cpufreq/boost") {
        Ok(f) => f,
        Err(e) => {
            eprintln!("{}", e);
            return Err(e);
        },
    };

    let boost : i32 = get_boost(&mut file)?;

    if boost == 1 {
        println!("Turboboost deactivated");
    } else {
        println!("Turboboost activated");
    }

    file.write_all((1-boost).to_string().as_bytes())?;
    Ok(())
}

fn get_boost(file : &mut File) -> io::Result<i32> {
    let mut read = BufReader::new(file);
    let mut line = String::new();
    read.read_line(&mut line)?;
    Ok(line.trim().parse().unwrap())
}
